(******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***   RShutdown2, my "famous" remote reboot utility.                       ***
 ***                                                                        ***
 ***   Version [1.60]                               {Last mod 2004-08-06}   ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 ******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***                Copyright (c) 1995 - 2004 by -=Assarbad=-               ***
 ***                                                                        ***
 ***   CONTACT TO THE AUTHOR(S):                                            ***
 ***    ____________________________________                                ***
 ***   |                                    |                               ***
 ***   | -=Assarbad=- aka Oliver            |                               ***
 ***   |____________________________________|                               ***
 ***   |                                    |                               ***
 ***   | Assarbad@gmx.info|.net|.com|.de    |                               ***
 ***   | ICQ: 281645                        |                               ***
 ***   | AIM: nixlosheute                   |                               ***
 ***   |      nixahnungnicht                |                               ***
 ***   | MSN: Assarbad@ePost.de             |                               ***
 ***   | YIM: sherlock_holmes_and_dr_watson |                               ***
 ***   |____________________________________|                               ***
 ***             ___                                                        ***
 ***            /   |                     ||              ||                ***
 ***           / _  |   ________ ___  ____||__    ___   __||                ***
 ***          / /_\ |  / __/ __//   |/  _/|   \  /   | /   |                ***
 ***         / ___  |__\\__\\  / /\ || |  | /\ \/ /\ |/ /\ | DOT NET        ***
 ***        /_/   \_/___/___/ /_____\|_|  |____/_____\\__/\|                ***
 ***       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~        ***
 ***              [http://assarbad.net | http://assarbad.org]               ***
 ***                                                                        ***
 ***   Notes:                                                               ***
 ***   - my first name is Oliver, you may well use this in your e-mails     ***
 ***   - for questions and/or proposals drop me a mail or instant message   ***
 ***                                                                        ***
 ***~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~***
 ***              May the source be with you, stranger ... ;)               ***
 ***    Snizhok, eto ne tolko fruktovij kefir, snizhok, eto stil zhizn.     ***
 ***                     Vsem Privet iz Germanij                            ***
 ***                                                                        ***
 *** Greets from -=Assarbad=- fly to YOU =)                                 ***
 *** Special greets fly 2 Nico, Casper, SA, Pizza, Navarion, Eugen, Zhenja, ***
 *** Xandros, Melkij, Strelok etc pp.                                       ***
 ***                                                                        ***
 *** Thanks to:                                                             ***
 *** W.A. Mozart, Vivaldi, Beethoven, Poeta Magica, Kurtzweyl, Manowar,     ***
 *** Blind Guardian, Weltenbrand, In Extremo, Wolfsheim, Carl Orff, Zemfira ***
 *** ... most of my work was done with their music in the background ;)     ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 1995-2004, -=Assarbad=- ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/

 ******************************************************************************)

 {

 RShutdown2 v.1.60

 History:

 [2004-08-06]
 1.60
 - Substituted the original NT interface to send messages with a custom one
   which uses mailslots to send. This means the program will not require the
   Messenger service to be started on the local machine!
 [somewhen in 2001 ;)]
 1.50a
 - added XP style support
 1.50
 - slightly improved design
 - redesigned the main dialog. now BOFH and NORMAL mode use the same dialog.
 1.41c
 - cosmetics: Hyperlink window class is Whistler-compatible now
 - restructured source - now it is better reusable!
 1.41b
 - fixed a bug which lets the dialog windows appear behind the main window.
 1.41a
 - fixed some minor bugs. Thanks to Jerold Schulman.
   The bugs were:
     - console did not close after job finished.
     - no "/Y" parameter to prevent prompting on local shutdown
     + some other things I recognized myself ;)
 - changed the subsystem to CONSOLE thus allowing RShutdown2 to write to an
   already available console.
   The thing with it is, that GUI and CONSOLE are defined as two separate
   subsystems. Since that information is determined by a flag in the EXE
   information records in the PE you cannot choose it during a run of a program.
   That is a program can only be either GUI or CONSOLE not both. That does not
   mean that GUI apps aren't allowed to use CONSOLEs but they are not attached
   to a native console or create a new automatically.
   Since starting a process is almost always done by the operating system, there
   is even no workaround for that problem BUT making an app CONSOLE and
   detaching that console from the app if it is not run in command-line mode.
   That's simply what I did ;)
 1.41
 - added traybar menu
 - added "domain list" button
 - release
 1.40
 - added command-line support
 1.34
 - The status button will not flicker anymore, while moving the mouse
 on an item with hint.
 - The error log will scroll to the last item on refresh.
 - Double clicking the caption bar will minimize to tray. Just like
 the "Minimize" button
 - Fixed minor bug: The currcompname variable was set even
 if the serverdialog function was not successful
 - release
 }

program RShutdown2;
uses
  windows,
  shellapi,
  commdlg,
  commctrl,
  messages;

{$D 'RShutdown2 (c) 2001, 2004 -=Assarbad=-'} //insert the appname here
{$APPTYPE CONSOLE}
{$INCLUDE .\Include\CompilerSwitches.PAS}

{DEFINE STATUS_FIXED} //defines if the error log has a fixed font
{$R main.res}
{$R icon.res}
{$R XPstyle.res}
{$INCLUDE .\Include\HyperLink.PAS} //includes the Hyperlink-window class
{$INCLUDE .\Include\Consolehlp.PAS}
{$INCLUDE .\Include\NetSendMsg.PAS}

const
  MAX_PREFERRED_LENGTH = DWORD(-1);
  SV_TYPE_NT = $00001000;
  NERR_Success = 0;

  ID_LOGOFF = 3001;
  ID_SHUTDOWN = 3002;
  ID_RESTORE = 3003;
  ID_EXIT = 3004;
  ID_ABOUT = 3005;
  ID_REBOOT = 3006;
  ID_POWEROFF = 3007;
  ID_ABORT = 3008;
  MAXSIZE = 260;
  MAX_MSG = 1024;
  SC_TRAY = WM_USER + 666;
  WM_SHELLNOTIFY = WM_USER + 667;
  WM_REFRESH_ERRORLIST = WM_USER + 668;

  err = 'Error';
  success = 'Success';

  err_noentry = 'Could not find entry point for ';

  ServerBrowseDialogA0_name = 'ServerBrowseDialogA0';
  NetApiBufferFree_name = 'NetApiBufferFree';
  NetServerEnum_name = 'NetServerEnum';
  NetMessageBufferSend_name = 'NetMessageBufferSend';

  err_noNT = 'The program is designed to run on NT platforms only.';
  progname = 'RShutdown2 (c) 2001, 2004 -=Assarbad=-';

  action_shutdown = 'Shutdown';
  action_netsend = 'Sending Message';
  action_abortSD = 'Abort shutdown';

  local_shutdown_confirm = 'You are about to shutdown/reboot the local system or to log off. Do you wish to continue?';
  threadterminate_confirm = 'Currently another job is running. Terminate it?';

  thread_started = 'The work thread started' + #13#10#13#10;
  thread_ended = 'The work thread finished';

  SE_REMOTE_SHUTDOWN_NAME = 'SeRemoteShutdownPrivilege';
  SE_SHUTDOWN_NAME = 'SeShutdownPrivilege';

  filterstring = 'All files'#0'*.*'#0#0;

  IDD_DIALOG1 = 101;
  IDD_DIALOG2 = 102;
  IDC_BUTTON_CLOSE = 1000;
  IDC_BUTTON_MIN = 1001;
  IDC_BUTTON_BOFH = 1002;
  IDC_BUTTON_STATUS = 1003;
  IDC_BUTTON_SEND = 1004;
  IDC_EDIT_TEXT = 1005;
  IDC_BUTTON_REBOOT = 1006;
  IDC_BUTTON_ABORT = 1007;
  IDC_BUTTON_CLEAR = 1008;
  IDC_BUTTON_MACHINE = 1009;
  IDC_EDIT_MACHINES = 1010;
  IDC_BUTTON_PASTE = 1011;
  IDC_BUTTON_COPY = 1012;
  IDC_BUTTON_DOMAIN = 1013;
  IDC_BUTTON_LOADLIST = 1014;
  IDC_BUTTON_SAVELIST = 1015;
  IDC_CHECK1 = 1016;
  IDC_CHECK2 = 1017;
  IDC_SPIN1 = 1018;
  IDC_EDIT_DELAY = 1019;
  IDC_STATIC_ASSA_ICON = 1020;
  IDC_CUSTOM1 = 1021;
  IDC_CUSTOM2 = 1022;

  hint_IDC_BUTTON_MACHINE = 'Give the target machine';
  hint_IDC_CHECK1 = 'Reboot instead of only shutting down the system';
  hint_IDC_CHECK2 = 'Kill applications (non-saved work is lost)';
  hint_IDC_BUTTON_SEND = 'Send the above message (NET SEND like)';
  hint_IDC_BUTTON_REBOOT = 'Shutdown the system (local/remote)';
  hint_IDC_BUTTON_CLEAR = 'Clear the message field';
  hint_IDC_BUTTON_PASTE = 'Paste clipboard content to message field';
  hint_IDC_BUTTON_COPY = 'Copy all content of message field to clipboard';
  hint_IDC_BUTTON_CLOSE = 'Close the program';
  hint_IDC_BUTTON_MIN = 'Minimize program to system tray';
  hint_IDC_BUTTON_BOFH = 'Switch to hardcore BOFH mode or back to NORMAL mode ;)';
  hint_IDC_BUTTON_ABORT = 'Abort shutdown (local/remote)';
  hint_IDC_BUTTON_LOADLIST = 'Load a list of saved machine names';
  hint_IDC_BUTTON_SAVELIST = 'Save the list of machine names';
  hint_IDC_BUTTON_DOMAIN = 'List the available PCs of domain / workgroup in the edit field';
  hint_IDC_BUTTON_STATUS = 'About this program';

  bofhmodetxt = '&BOFH';
  normalmodetxt = '&Normal';

  mylink = 'http://assarbad.net';
  mymail = 'mailto: oliver@assarbad.net';

  cmd_help = '/help';
  cmd_send = '/send';
  cmd_reboot = '/reboot';
  cmd_shutdown = '/shutdown';
  cmd_abort = '/abort';

  cmd_file = '/file';
  cmd_machine = '/machine';

  cmd_yes = '/Y';

  press_anykey = #13#10#13#10 + 'Press any key to continue.';

  cmd_show_header = progname + ' [command line mode]' + #13#10;
  cmd_show_syntax = 'SYNTAX:'#9'RShutdown2 /[command type] [:"message"] /machine [machine name] /XX /Y' + #13#10#13#10 +
    'Instead of one machine name you may use a file with one machine name per line!' + #13#10#13#10 +
    #9 + 'RShutdown2 /[command type] [:"message"] /file [file name] /XX /Y' + #13#10#13#10 +
    'Command types are (without quotes):' + #13#10 +
    #9'"help"'#9#9'for this help screen' + #13#10 +
    #9'"send"'#9#9'to send a popup message using the messenger service' + #13#10 +
    #9'"reboot"'#9'to reboot a machine and optionally send a warning' + #13#10 +
    #9'"shutdown"'#9'to shutdown the machine and optionally send a warning' + #13#10 +
    #9'"abort"'#9#9'to abort a shutdown (abort takes NO MESSAGE TEXT!)' + #13#10 +
    'Parameters are:' + #13#10 +
    #9'/XX'#9#9'is durations in seconds where XX is a decimal number!' + #13#10 +
    #9#9#9'More than two digits are explicitly allowed ;)' + #13#10 +
    #9#9#9'Send and abort mode ignore this value.' + #13#10 +
    #9'/Y'#9#9'Will not prompt on local shutdown in CMD mode.' + #13#10 +
    'Note:'#9'IN SEND-MODE YOU HAVE TO GIVE A MESSAGE. Do not forget to set a message' + #13#10 +
    #9'in quotes nor forget to set a filename in quotes if it contains blank' + #13#10 +
    #9'spaces. It does not matter if machine name has a trailing "\\".' + #13#10 +
    #9'Always stick to the order of parameters.';

type
  PSERVER_INFO_100 = ^TSERVER_INFO_100;
  TSERVER_INFO_100 = packed record
    sv100_platform_id: INTEGER;
    sv100_name: PWideChar;
  end;
  NET_API_STATUS = DWORD;
  TNetApiBufferFree = function(Buffer: Pointer): NET_API_STATUS; stdcall;
  TNetServerEnum = function(servername: PWideChar; level: DWORD; var bufptr: pointer; prefmaxlen: DWORD; var entriesread, totalentries: integer; servertype: DWORD; domain: PWideChar; var resume_handle: integer): NET_API_STATUS; stdcall;
  TServerBrowseDialogA0 = function(hwnd: HWND; pchBuffer: pointer; cchBufSize: DWord): bool; stdcall;
  TThreadBuffer = packed record
    request_type: byte;
    message: string;
    force,
      boot: boolean;
    duration: Longint;
    systems: array of string;
  end;

var
  BOFH: boolean = FALSE;
  noPrompt: boolean = FALSE;
  NIL_HANDLE: Integer absolute 0;
  currtextattr: word;
  cmds: array[0..4] of string;
  osinfo: TOSVERSIONinfo;
  appIcon, LANMAN_DLL: DWORD;
  commandtype: integer = -1;
  size: Cardinal;
  hdlg: DWORD = 0;
  hdlg2: DWORD = 0;
  ServerBrowseDialogA0: TServerBrowseDialogA0 = nil;
  NetServerEnum: TNetServerEnum = nil;
  NetApiBufferFree: TNetApiBufferFree = nil;
  compname: string = '';
  currcompname: string;
  cbuffer: array[0..16] of char;
  glob_errorcode: integer = 0;
  error_list: string = '';
  note: TNotifyIconData;

  hPopupMenu, hSysMenu, ThreadID: DWORD;
  Threadruns: boolean = FALSE;
  Threadhandle: DWORD = 0;
  Threadbuffer: TThreadbuffer;

  ofn: TOpenFilename;
  ofn_buffer: array[0..MAXSIZE - 1] of Char;

  varfont6, varfont12, varfont10, fixedfont8: Cardinal;

function _strtoint(v: string): Integer;
var
  code: integer;
begin
  val(v, result, code);
end;

function _inttostr(v: integer): string;
begin
  str(v, result);
end;

function GetErrorMessage(code: Integer; loadnet: boolean = TRUE): string;
var
  hErrLib: DWORD;
  msg: PChar;
  flags: integer;

  function MAKELANGID(p, s: word): Integer;
  begin
    result := (s shl 10) or p
  end;

begin
  case loadnet of
    true: hErrLib := LoadLibraryEx('NETMSG.DLL', 0, LOAD_LIBRARY_AS_DATAFILE);
    false: hErrLib := 0;
  end;
  try
    flags := FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_IGNORE_INSERTS or FORMAT_MESSAGE_FROM_SYSTEM;
    case (hErrLib <> 0) of
      false: flags := flags or FORMAT_MESSAGE_FROM_HMODULE;
    end;
    if FormatMessage(flags,
      pointer(hErrLib),
      code,
      integer((SUBLANG_DEFAULT shl 10) or LANG_NEUTRAL),
      pchar(@msg),
      0,
      nil) <> 0 then
      result := string(msg);
    LocalFree(Integer(msg));
  finally
    if hErrLib <> 0 then FreeLibrary(hErrLib)
  end
end;

function FileExists(const FileName: string; dir: boolean = false): Boolean;
var
  hidate, lodate: word;
  Handle: THandle;
  FindData: TWin32FindData;
  LocalFileTime: TFileTime;

type
  LongRec = packed record
    Lo, Hi: Word;
  end;

  function SubFileExists: Boolean;
  begin
    FileTimeToLocalFileTime(FindData.ftLastWriteTime, LocalFileTime);
    result := FileTimeToDosDateTime(LocalFileTime, HiDate, LoDate);
  end;
begin
  result := false;
  Handle := FindFirstFile(PChar(FileName), FindData);
  if Handle <> INVALID_HANDLE_VALUE then
  begin
    Windows.FindClose(Handle);
    case dir of
      TRUE: if (FindData.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) <> 0 then result := SubFileExists;
      FALSE: if (FindData.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = 0 then result := SubFileExists;
    end;
  end;
end;

function StatusWindowProc(hWnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
var
  pc: Pchar;
  dw: DWORD;
  point: TPoint;
  rect: TRect;
begin
  dw := 0;
  case Msg of
    WM_CAPTURECHANGED,
      WM_MOUSEMOVE:
      begin
        GetCursorPos(point);
        GetWindowRect(hwnd, rect);
        if PtInRect(rect, point) then begin
          if GetCapture <> hWnd then begin
            SetCapture(hWnd);
            pc := Pchar(GetProp(hWnd, 'Status_Hint'));
            sendmessage(hWnd, WM_GETTEXT, 0, dw);
            if Pchar(dw) <> pc then
              if pc <> nil then setdlgitemtext(hDlg, IDC_BUTTON_STATUS, pc);
          end;
        end else begin
          ReleaseCapture;
          setdlgitemtext(hDlg, IDC_BUTTON_STATUS, progname);
        end;
      end;
  end;
  result := CallWindowProc(pointer(GetProp(hWnd, 'Status_OrigWndProc')), hWnd, Msg, wParam, lParam);
end;

procedure sethint(hwnd: HWND; hint: pchar);
begin
  SetProp(hWnd, 'Status_Hint', DWORD(hint));
  SetProp(hWnd, 'Status_OrigWndProc', DWORD(SetWindowLong(hwnd, GWL_WNDPROC, Integer(@StatusWindowProc))));
end;

procedure adderror(action, system: string; code: integer = 0);
var
  dummy: string;
begin
  case commandtype of
    -1: begin
        case system = '' of
          TRUE: begin
              dummy := action + #13#10;
            end;
          FALSE: begin
              dummy := 'Action: ' + action + ' [' + system + ']' + #13#10;
              case code of
                0: dummy := dummy + success + ': ' + Geterrormessage(code);
              else dummy := dummy + err + ':' + #13#10 + Geterrormessage(code);
              end;
            end;
        end;
        error_list := error_list + dummy + #13#10;
      end;
  else begin
      currtextattr := textattribute;
      case system = '' of
        TRUE: begin
            settextattribute(FOREGROUND_RED or FOREGROUND_INTENSITY);
            writeln(action);
            settextattribute(currtextattr);
          end;
        FALSE: begin
            settextattribute(FOREGROUND_BLUE or FOREGROUND_INTENSITY);
            write('Action:  ');
            settextattribute(currtextattr);
            writeln(action + ' [' + system + ']');
            case code of
              0: begin
                  dummy := success + ':';
                  settextattribute(FOREGROUND_GREEN or FOREGROUND_INTENSITY);
                end;
            else begin
                dummy := err + ':';
                settextattribute(FOREGROUND_RED or FOREGROUND_INTENSITY);
              end;
            end;
            writeln(dummy);
            settextattribute(currtextattr);
            writeln(Geterrormessage(code));
          end;
      end;
    end;
  end; //case
end;

procedure emptyerror;
begin
  error_list := '';
  setlength(ThreadBuffer.systems, 1);
  ZeroMemory(@ThreadBuffer, sizeof(Threadbuffer));
end;

function ischecked(btn: integer): boolean;
begin
  result := isdlgbuttonchecked(hdlg, btn) = BST_CHECKED;
end;

function shut(system, message: string; force, reboot: boolean; duration: integer; FLAGS: DWORD = 0): integer;
var
  otoken, hToken: THandle;
  tp: TTokenPrivileges;
  h: Dword;
  ch: char;
begin
  result := 0;
  case lstrcmpi(pchar(compname), pchar(system)) of
    0: begin
        case commandtype of
          -1: if messagebox(hDlg, local_shutdown_confirm, 'Confirm', MB_ICONQUESTION or MB_YESNO) = IDNO then exit;
        else begin
            write(local_shutdown_confirm + ' (Y for yes): ');
            case noPrompt of
              TRUE: writeln('y');
              FALSE: begin
                  repeat
                    ch := readkey;
                  until ch in ['Y', 'y', 'N', 'n'];
                  writeln(ch);
                  case ch in ['Y', 'y'] of
                    FALSE: begin
                        AddError('No shutdown!', '');
                        result := 5;
                        exit;
                      end;
                  end;
                end;
            end;
          end;
        end;
        OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES, hToken);
        otoken := htoken;
        LookupPrivilegeValue(nil, SE_SHUTDOWN_NAME, tp.Privileges[0].luid);
        tp.privilegecount := 1;
        tp.privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
        h := 0;
        AdjustTokenPrivileges(hToken, False, tp, 0, PTokenPrivileges(nil)^, h);
        case duration of
          -1: case force of
              TRUE: ExitWindowsEx(FLAGS or EWX_FORCE, 0);
              FALSE: ExitWindowsEx(FLAGS, 0);
            end;
        else InitiateSystemShutdown(nil, pchar(message), duration, force, reboot);
        end;
        result := getlasterror;
        tp.privilegecount := 1;
        tp.privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
        h := 0;
        AdjustTokenPrivileges(oToken, False, tp, 0, PTokenPrivileges(nil)^, h);
        CloseHandle(hToken);
      end;
  else begin
      OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES, hToken);
      otoken := htoken;
      LookupPrivilegeValue(pchar(system), SE_REMOTE_SHUTDOWN_NAME, tp.Privileges[0].luid);
      tp.privilegecount := 1;
      tp.privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
      h := 0;
      AdjustTokenPrivileges(hToken, False, tp, 0, PTokenPrivileges(nil)^, h);
      InitiateSystemShutdown(pchar(system), pchar(message), duration, force, reboot);
      result := getlasterror;
      tp.privilegecount := 1;
      tp.privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
      h := 0;
      AdjustTokenPrivileges(oToken, False, tp, 0, PTokenPrivileges(nil)^, h);
      CloseHandle(hToken);
    end;
  end;
end;

function abortshut(system: string): integer;
var
  hToken: THandle;
  tp: TTokenPrivileges;
  h: Dword;
begin
  case lstrcmpi(pchar(compname), pchar(system)) of
    0: begin
        OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES, hToken);
        LookupPrivilegeValue(nil, SE_SHUTDOWN_NAME, tp.Privileges[0].luid);
        tp.privilegecount := 1;
        tp.privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
        h := 0;
        AdjustTokenPrivileges(hToken, False, tp, 0, PTokenPrivileges(nil)^, h);
        CloseHandle(hToken);
        abortSystemShutdown(nil);
        result := getlasterror;
      end;
  else begin
      OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES, hToken);
      LookupPrivilegeValue(pchar(system), SE_REMOTE_SHUTDOWN_NAME, tp.Privileges[0].luid);
      tp.privilegecount := 1;
      tp.privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
      h := 0;
      AdjustTokenPrivileges(hToken, False, tp, 0, PTokenPrivileges(nil)^, h);
      CloseHandle(hToken);
      abortSystemShutdown(pchar(system));
      result := getlasterror;
    end;
  end;
end;

function dlgfunc_about(hwnd: hwnd; umsg: dword; wparam: wparam; lparam: lparam): bool; stdcall;
var
{$IFDEF STATUS_FIXED}
  fixedfont: DWORD;
{$ENDIF}
  _lines_, dw1, dw2: integer;
begin
  result := true;
  case umsg of
    WM_INITDIALOG:
      begin
        hdlg2 := hwnd;
        sendmessage(hwnd, WM_SETTEXT, 0, Longint(pchar(progname)));
{$IFDEF STATUS_FIXED}
        fixedfont := CreateFont(-MulDiv(6, GetDeviceCaps(GetWindowDC(hwnd), LOGPIXELSY), 72), 0, 0, 0, FW_NORMAL, 0, 0, 0, ANSI_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, FIXED_PITCH or FF_MODERN, 'Courier');
        sendmessage(Getdlgitem(hwnd, IDC_EDIT1), WM_SETFONT, fixedfont, LongInt(TRUE));
{$ENDIF}
        Setdlgitemtext(hwnd, IDC_EDIT_TEXT, pchar(error_list));
        setprop(Getdlgitem(hwnd, IDC_CUSTOM1), 'Link', Longint(pchar(mylink)));
        setprop(Getdlgitem(hwnd, IDC_CUSTOM2), 'Link', Longint(pchar(mymail)));
      end;
    WM_REFRESH_ERRORLIST:
      begin
        Setdlgitemtext(hwnd, IDC_EDIT_TEXT, pchar(error_list));
        _lines_ := Sendmessage(getdlgitem(hwnd, IDC_EDIT_TEXT), EM_GETLINECOUNT, 0, 0);
        Sendmessage(Getdlgitem(hwnd, IDC_EDIT_TEXT), EM_LINESCROLL, 0, _lines_ - 3);
      end;
    WM_CLOSE:
      begin
        hdlg2 := 0;
        EndDialog(hWnd, 0);
      end;
    WM_COMMAND:
      if hiword(wparam) = BN_CLICKED then begin
        case loword(wparam) of
          IDC_BUTTON_CLOSE:
            sendmessage(hwnd, WM_CLOSE, 0, 0);
          IDC_BUTTON_COPY:
            begin
              Sendmessage(Getdlgitem(hwnd, IDC_EDIT_TEXT), EM_GETSEL, Longint(@dw1), Longint(@dw2));
              Sendmessage(Getdlgitem(hwnd, IDC_EDIT_TEXT), EM_SETSEL, 0, -1);
              Sendmessage(Getdlgitem(hwnd, IDC_EDIT_TEXT), WM_COPY, 0, 0);
              Sendmessage(Getdlgitem(hwnd, IDC_EDIT_TEXT), EM_SETSEL, dw1, dw2);
              SetFocus(Getdlgitem(hwnd, IDC_EDIT_TEXT));
            end;
          IDC_BUTTON_CLEAR:
            begin
              Sendmessage(Getdlgitem(hwnd, IDC_EDIT_TEXT), WM_SETTEXT, 0, 0);
              SetFocus(Getdlgitem(hwnd, IDC_EDIT_TEXT));
            end;
        end;
      end;
  else result := false;
  end;
end;

function Threadfunc(x: POINTER): DWORD; stdcall;
var i: integer;
begin
  threadruns := true;
  AddError(thread_started, '');
  if commandtype = -1 then if hdlg2 <> 0 then sendmessage(hdlg2, WM_REFRESH_ERRORLIST, 0, 0);
  result := 0;
  case Threadbuffer.request_type of
    1: //Shutdown
      begin
        for i := 0 to length(Threadbuffer.systems) - 1 do begin
          glob_errorcode := shut(Threadbuffer.systems[i], Threadbuffer.message, Threadbuffer.force, Threadbuffer.boot, Threadbuffer.duration);
          adderror(action_shutdown, Threadbuffer.systems[i], glob_errorcode);
          if commandtype = -1 then if hdlg2 <> 0 then sendmessage(hdlg2, WM_REFRESH_ERRORLIST, 0, 0);
        end;
        result := Threadbuffer.request_type;
      end;
    2: //Abort
      begin
        for i := 0 to length(Threadbuffer.systems) - 1 do begin
          glob_errorcode := abortshut(Threadbuffer.systems[i]);
          adderror(action_abortSD, Threadbuffer.systems[i], glob_errorcode);
          if commandtype = -1 then if hdlg2 <> 0 then sendmessage(hdlg2, WM_REFRESH_ERRORLIST, 0, 0);
        end;
        result := Threadbuffer.request_type;
      end;
    3: //Send
      begin
        for i := 0 to length(Threadbuffer.systems) - 1 do begin
          glob_errorcode := NetSendMsg(Threadbuffer.systems[i], Threadbuffer.message);
          adderror(action_netsend, Threadbuffer.systems[i], glob_errorcode);
          if commandtype = -1 then if hdlg2 <> 0 then sendmessage(hdlg2, WM_REFRESH_ERRORLIST, 0, 0);
        end;
        result := Threadbuffer.request_type;
      end;
  end;
  AddError(thread_ended, '');
  if commandtype = -1 then if hdlg2 <> 0 then sendmessage(hdlg2, WM_REFRESH_ERRORLIST, 0, 0);
  threadruns := false;
end;

function can_start: boolean;
begin
  result := not threadruns;
  case result of
    FALSE: begin
        result := messagebox(hDlg, threadterminate_confirm, 'Confirm', MB_ICONQUESTION or MB_YESNO) = IDYES;
        if result then TerminateThread(ThreadHandle, 0);
      end;
  end;

end;

procedure addstring(hwnd: HWND; s: string);
begin
  SendMessage(hWnd, LB_ADDSTRING, 0, lParam(Pchar(s)));
end;

procedure VisibleWindow(hwnd: HWND; visible: boolean);
begin
  case visible of
    TRUE: ShowWindow(hwnd, SW_SHOWNOACTIVATE);
    FALSE: ShowWindow(hwnd, SW_HIDE);
  end;
end;

function dlgfunc(hwnd: hwnd; umsg: dword; wparam: wparam; lparam: lparam): bool; stdcall;
var
  SizeWritten: DWORD;
  dw1, dw2: integer;
  pc: pchar;
  point: TPoint;

  itms: integer;
  names: array of string[16];
  buffer,
    buf: array[0..MAX_MSG] of char;
  lpTranslated: bool;
  hFileWrite, hFileRead, hMapfile: DWORD;

  err, i: cardinal;
  x: pointer;
  p: PSERVER_INFO_100;
  _read, _total: integer;
  dummy: string;

  procedure GETITEMS;
  var i: integer;
    Text: array[0..4095] of Char;

    function GetCount: Integer;
    begin
      Result := SendMessage(getdlgitem(hwnd, IDC_EDIT_MACHINES), EM_GETLINECOUNT, 0, 0);
      if SendMessage(getdlgitem(hwnd, IDC_EDIT_MACHINES), EM_LINELENGTH, SendMessage(getdlgitem(hwnd, IDC_EDIT_MACHINES), EM_LINEINDEX, Result - 1, 0), 0) = 0 then Dec(Result);
    end;

  begin
    itms := getcount;
    setlength(names, 0);
    for i := 0 to itms - 1 do begin
      zeromemory(@Text, sizeof(Text));
      Word((@Text)^) := SizeOf(Text);
      SendMessage(getdlgitem(hwnd, IDC_EDIT_MACHINES), EM_GETLINE, i, Longint(@Text));
      dummy := string(pchar(@text));
      if dummy <> '' then begin
        setlength(names, length(names) + 1);
        while dummy[1] = '\' do delete(dummy, 1, 1);
        dummy := '\\' + dummy;
        names[length(names) - 1] := dummy;
      end;
    end;
  end;

  procedure CloseMapFile;
  begin
    CloseHandle(hMapFile);
    hMapFile := 0;
    CloseHandle(hFileRead);
  end;

  procedure about_proc;
  begin
    DialogBox(HInstance, MAKEINTRESOURCE(IDD_DIALOG2), hwnd, @DlgFunc_about);
    SetFocus(Getdlgitem(hwnd, IDC_EDIT_TEXT));
  end;

  procedure bofhcheck;
  begin
    EnableWindow(getdlgitem(hwnd, IDC_BUTTON_LOADLIST), bofh);
    EnableWindow(getdlgitem(hwnd, IDC_BUTTON_SAVELIST), bofh);
    EnableWindow(getdlgitem(hwnd, IDC_BUTTON_DOMAIN), bofh);
    EnableWindow(getdlgitem(hwnd, IDC_EDIT_MACHINES), bofh);
    EnableWindow(getdlgitem(hwnd, IDC_BUTTON_MACHINE), not bofh);
    VisibleWindow(getdlgitem(hwnd, IDC_BUTTON_LOADLIST), bofh);
    VisibleWindow(getdlgitem(hwnd, IDC_BUTTON_SAVELIST), bofh);
    VisibleWindow(getdlgitem(hwnd, IDC_BUTTON_DOMAIN), bofh);
    VisibleWindow(getdlgitem(hwnd, IDC_EDIT_MACHINES), bofh);
    VisibleWindow(getdlgitem(hwnd, IDC_BUTTON_MACHINE), not bofh);
    Setdlgitemtext(hwnd, IDC_BUTTON_STATUS, Pchar(progname));
    case BOFH of
      TRUE: begin
          sendmessage(hwnd, WM_SETTEXT, 0, Longint(pchar(progname + ' [BOFH]')));
          Setdlgitemtext(hwnd, IDC_EDIT_MACHINES, Pchar(compname));
          Setdlgitemtext(hwnd, IDC_BUTTON_BOFH, Pchar(normalmodetxt));
        end;
      FALSE: begin
          sendmessage(hwnd, WM_SETTEXT, 0, Longint(pchar(progname + ' [NORM]')));
          Setdlgitemtext(hwnd, IDC_BUTTON_MACHINE, Pchar(compname));
          Setdlgitemtext(hwnd, IDC_BUTTON_BOFH, Pchar(bofhmodetxt));
        end;
    end;
  end;

begin
  result := true;
  case umsg of
    WM_INITDIALOG:
      begin
        hDlg := hWnd;
        CheckDlgButton(hwnd, IDC_CHECK1, BST_CHECKED);
        CheckDlgButton(hwnd, IDC_CHECK2, BST_CHECKED);
        Setdlgitemtext(hwnd, IDC_EDIT_DELAY, '0');
        fixedfont8 := CreateFont(-MulDiv(8, GetDeviceCaps(GetWindowDC(hwnd), LOGPIXELSY), 72), 0, 0, 0, FW_NORMAL, 0, 0, 0, ANSI_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, FIXED_PITCH or FF_MODERN, 'Courier');
        varfont6 := CreateFont(-MulDiv(7, GetDeviceCaps(GetWindowDC(hwnd), LOGPIXELSY), 72), 0, 0, 0, FW_NORMAL, 0, 0, 0, ANSI_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, VARIABLE_PITCH or FF_MODERN, 'Arial');
        varfont10 := CreateFont(-MulDiv(10, GetDeviceCaps(GetWindowDC(hwnd), LOGPIXELSY), 72), 0, 0, 0, FW_MEDIUM, 0, 0, 0, ANSI_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, VARIABLE_PITCH or FF_MODERN, 'Arial');
        varfont12 := CreateFont(-MulDiv(12, GetDeviceCaps(GetWindowDC(hwnd), LOGPIXELSY), 72), 0, 0, 0, FW_BOLD, 0, 0, 0, ANSI_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, VARIABLE_PITCH or FF_MODERN, 'Arial');
        sendmessage(Getdlgitem(hwnd, IDC_EDIT_DELAY), WM_SETFONT, fixedfont8, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_EDIT_MACHINES), WM_SETFONT, fixedfont8, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_BUTTON_MACHINE), WM_SETFONT, varfont12, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_BUTTON_DOMAIN), WM_SETFONT, varfont6, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_BUTTON_LOADLIST), WM_SETFONT, varfont6, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_BUTTON_SAVELIST), WM_SETFONT, varfont6, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_EDIT_TEXT), WM_SETFONT, varfont10, LongInt(TRUE));

        sendmessage(Getdlgitem(hwnd, IDC_SPIN1), UDM_SETRANGE, 0, MAKELONG($7FFF, 0));
        sendmessage(Getdlgitem(hwnd, IDC_SPIN1), UDM_SETBUDDY, Getdlgitem(hwnd, IDC_EDIT_DELAY), 0);

        sendmessage(Getdlgitem(hwnd, IDC_EDIT_TEXT), EM_LIMITTEXT, MAX_MSG, 0);
        sendmessage(Getdlgitem(hwnd, IDC_EDIT_MACHINES), EM_LIMITTEXT, $FFFF, 0);
        bofhcheck;

        sethint(getdlgitem(hwnd, IDC_BUTTON_LOADLIST), pchar(hint_IDC_BUTTON_LOADLIST));
        sethint(getdlgitem(hwnd, IDC_BUTTON_SAVELIST), pchar(hint_IDC_BUTTON_SAVELIST));
        sethint(getdlgitem(hwnd, IDC_BUTTON_DOMAIN), pchar(hint_IDC_BUTTON_DOMAIN));
        sethint(getdlgitem(hwnd, IDC_BUTTON_MACHINE), pchar(hint_IDC_BUTTON_MACHINE));
        sethint(getdlgitem(hwnd, IDC_BUTTON_BOFH), pchar(hint_IDC_BUTTON_BOFH));
        sethint(getdlgitem(hwnd, IDC_CHECK1), pchar(hint_IDC_CHECK1));
        sethint(getdlgitem(hwnd, IDC_CHECK2), pchar(hint_IDC_CHECK2));
        sethint(getdlgitem(hwnd, IDC_BUTTON_SEND), pchar(hint_IDC_BUTTON_SEND));
        sethint(getdlgitem(hwnd, IDC_BUTTON_REBOOT), pchar(hint_IDC_BUTTON_REBOOT));
        sethint(getdlgitem(hwnd, IDC_BUTTON_CLEAR), pchar(hint_IDC_BUTTON_CLEAR));
        sethint(getdlgitem(hwnd, IDC_BUTTON_PASTE), pchar(hint_IDC_BUTTON_PASTE));
        sethint(getdlgitem(hwnd, IDC_BUTTON_COPY), pchar(hint_IDC_BUTTON_COPY));
        sethint(getdlgitem(hwnd, IDC_BUTTON_CLOSE), pchar(hint_IDC_BUTTON_CLOSE));
        sethint(getdlgitem(hwnd, IDC_BUTTON_MIN), pchar(hint_IDC_BUTTON_MIN));
        sethint(getdlgitem(hwnd, IDC_BUTTON_ABORT), pchar(hint_IDC_BUTTON_ABORT));
        sethint(getdlgitem(hwnd, IDC_BUTTON_STATUS), pchar(hint_IDC_BUTTON_STATUS));

        hSYSMenu := GetSystemMenu(hwnd, false);
        DeleteMenu(hSysMenu, SC_MAXIMIZE, MF_BYCOMMAND);
        DeleteMenu(hSysMenu, SC_RESTORE, MF_BYCOMMAND);
        DeleteMenu(hSysMenu, SC_SIZE, MF_BYCOMMAND);

        hPopupmenu := CreatePopupMenu;
        AppendMenu(hpopupmenu, MF_STRING, ID_LOGOFF, '&Log off');
        AppendMenu(hpopupmenu, MF_STRING, ID_SHUTDOWN, '&Shutdown');
        AppendMenu(hpopupmenu, MF_STRING, ID_REBOOT, 'Reb&oot');
        AppendMenu(hpopupmenu, MF_STRING, ID_POWEROFF, '&Power off');
        AppendMenu(hpopupmenu, MF_STRING, ID_ABORT, '&Abort shutdown');
        AppendMenu(hpopupmenu, MF_STRING, MF_SEPARATOR, nil);
        AppendMenu(hpopupmenu, MF_STRING, ID_RESTORE, '&Restore');
        AppendMenu(hpopupmenu, MF_STRING, ID_EXIT, 'E&xit program');
        AppendMenu(hpopupmenu, MF_STRING, MF_SEPARATOR, nil);
        AppendMenu(hpopupmenu, MF_STRING, ID_ABOUT, '&About');

        sendmessage(hwnd, WM_SETICON, ICON_BIG, appIcon);
        sendmessage(hwnd, WM_SETICON, ICON_SMALL, appIcon);
      end;
    WM_CLOSE:
      EndDialog(hWnd, 0);
    WM_DESTROY:
      begin
        DestroyMenu(hPopupMenu);
        getsystemmenu(hwnd, TRUE);
        Shell_NotifyIcon(NIM_DELETE, @note);
      end;
    WM_CTLCOLORSTATIC:
      begin
        SetTextColor(wParam, RGB(18, 18, 132));
        SetBkColor(wParam, GetSysColor(COLOR_3DFACE));
        result := BOOL(GetSysColorBrush(COLOR_3DFACE));
      end;
    WM_CTLCOLORDLG:
      result := BOOL(GetSysColorBrush(COLOR_3DFACE));
    WM_CTLCOLOREDIT:
      case GetDlgCtrlID(lParam) of
        IDC_EDIT_TEXT:
          begin
            SetTextColor(wParam, RGB(18, 18, 232));
            SetBkColor(wParam, GetSysColor(COLOR_3DFACE));
            result := BOOL(GetSysColorBrush(COLOR_3DFACE));
          end;
        IDC_EDIT_DELAY:
          begin
            SetTextColor(wParam, RGB(18, 18, 132));
            SetBkColor(wParam, GetSysColor(COLOR_3DFACE));
            result := BOOL(GetSysColorBrush(COLOR_3DFACE));
          end;
        IDC_EDIT_MACHINES:
          begin
            SetTextColor(wParam, RGB(18, 18, 232));
            SetBkColor(wParam, GetSysColor(COLOR_3DFACE));
            result := BOOL(GetSysColorBrush(COLOR_3DFACE));
          end;
      else result := false;
      end;
    WM_SIZE:
      if wParam = SIZE_MINIMIZED then begin
        note.cbSize := SizeOf(TNotifyIconData);
        note.Wnd := hWnd;
        note.uID := SC_TRAY;
        note.uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
        note.uCallbackMessage := WM_SHELLNOTIFY;
        note.hIcon := Loadicon(hInstance, MAKEINTRESOURCE(1));
        lstrcpy(note.szTip, pchar(progname));
        ShowWindow(hWnd, SW_HIDE);
        Shell_NotifyIcon(NIM_ADD, @note);
      end;
    WM_SHELLNOTIFY:
      case wParam of
        SC_TRAY:
          case lParam of
            WM_LBUTTONDBLCLK:
              SendMessage(hWnd, WM_COMMAND, ID_RESTORE, 0);
            WM_RBUTTONDOWN:
              begin
                GetCursorPos(point);
                SetForegroundWindow(hWnd);
                TrackPopupMenu(hPopupMenu, TPM_RIGHTALIGN or TPM_BOTTOMALIGN, point.x, point.y, 0, hwnd, nil);
                PostMessage(hWnd, WM_NULL, 0, 0);
              end;
          end;
      end;
    WM_NCLBUTTONDBLCLK:
      begin
        case wParam = HTCAPTION of
          TRUE: Showwindow(hwnd, SW_MINIMIZE);
        end;
      end;
    WM_COMMAND:
      case lParam of
        0: begin
            case LoWord(wParam) of
              ID_RESTORE:
                begin
                  Shell_NotifyIcon(NIM_DELETE, @note);
                  ShowWindow(hWnd, SW_RESTORE);
                  SetForeGroundWindow(hwnd);
                end;
              ID_EXIT:
                begin
                  Shell_NotifyIcon(NIM_DELETE, @note);
                  sendmessage(hwnd, WM_SYSCOMMAND, SC_CLOSE, 0);
                end;
              ID_ABOUT:
                about_proc;
              ID_REBOOT:
                shut(compname, '', false, false, -1, EWX_REBOOT);
              ID_SHUTDOWN:
                shut(compname, '', false, false, -1, EWX_SHUTDOWN);
              ID_LOGOFF:
                shut(compname, '', false, false, -1, EWX_LOGOFF);
              ID_POWEROFF:
                shut(compname, '', false, false, -1, EWX_POWEROFF);
              ID_ABORT:
                AbortShut(compname);
            end;
          end;
      else begin
          if hiword(wparam) = BN_CLICKED then begin
            case loword(wparam) of
              IDC_BUTTON_DOMAIN:
                if BOFH then begin
                  dummy := '';
                  err := NetServerEnum(nil, 100, x, MAX_PREFERRED_LENGTH, _read, _total, SV_TYPE_NT, nil, NIL_HANDLE);
                  if err = NERR_Success then
                  try
                    p := PSERVER_INFO_100(x);
                    for i := 0 to _Read - 1 do begin
                      dummy := dummy + string(pwidechar(p^.sv100_name)) + #13#10;
                      Inc(p);
                    end;
                  finally
                    NetAPIBufferFree(x);
                  end;
                  setdlgitemtext(hwnd, IDC_EDIT_MACHINES, pchar(dummy));
                  setfocus(getdlgitem(hwnd, IDC_EDIT_MACHINES));
                end;
              IDC_BUTTON_SAVELIST:
                if BOFH then begin
                  ofn.lStructSize := SizeOf(TOpenFilename);
                  ofn.hWndOwner := hwnd;
                  ofn.hInstance := HInstance;
                  ofn.lpstrFilter := filterstring;
                  ofn.lpstrFile := ofn_buffer;
                  ofn.nMaxFile := MAXSIZE;
                  ofn.Flags := OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY;
                  if GetSaveFileName(ofn) then begin
                    hFileWrite := CreateFile(ofn_buffer, GENERIC_READ or GENERIC_WRITE, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, CREATE_ALWAYS, FILE_ATTRIBUTE_ARCHIVE, 0);
                    getmem(pc, $FFFF);
                    Getdlgitemtext(hwnd, IDC_EDIT_MACHINES, pc, $FFFF);
                    WriteFile(hFileWrite, pc^, lstrlen(pc), SizeWritten, nil);
                    Zeromemory(pc, $FFFF);
                    freemem(pc);
                    CloseHandle(hFileWrite);
                  end;

                end;
              IDC_BUTTON_LOADLIST:
                if BOFH then begin
                  ofn.lStructSize := SizeOf(TOpenFilename);
                  ofn.hWndOwner := hwnd;
                  ofn.hInstance := HInstance;
                  ofn.lpstrFilter := filterstring;
                  ofn.lpstrFile := ofn_buffer;
                  ofn.nMaxFile := MAXSIZE;
                  ofn.Flags := OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY;
                  if GetOpenFileName(ofn) then begin
                    hFileRead := CreateFile(ofn_buffer, GENERIC_READ, 0, nil, OPEN_EXISTING, FILE_ATTRIBUTE_ARCHIVE, 0);
                    hMapFile := CreateFileMapping(hFileRead, nil, PAGE_READONLY, 0, 0, nil);
                    pc := MapViewOfFile(hMapFile, FILE_MAP_READ, 0, 0, 0);
                    SetDlgItemText(hWnd, IDC_EDIT_MACHINES, pc);
                    UnmapViewOfFile(pc);
                    CloseMapFile;
                  end;
                end;
              IDC_BUTTON_STATUS:
                about_proc;
              IDC_BUTTON_MIN:
                Showwindow(hwnd, SW_MINIMIZE);
              IDC_BUTTON_CLOSE:
                sendmessage(hwnd, WM_CLOSE, 0, 0);
              IDC_BUTTON_MACHINE:
                begin
                  ServerBrowseDialogA0(hwnd, @buffer, MAX_MSG);
                  if buffer[0] = '\' then begin
                    Setdlgitemtext(hwnd, IDC_BUTTON_MACHINE, Pchar(string(buffer)));
                    currcompname := string(buffer);
                  end;
                end;
              IDC_BUTTON_COPY:
                begin
                  Sendmessage(Getdlgitem(hwnd, IDC_EDIT_TEXT), EM_GETSEL, Longint(@dw1), Longint(@dw2));
                  Sendmessage(Getdlgitem(hwnd, IDC_EDIT_TEXT), EM_SETSEL, 0, -1);
                  Sendmessage(Getdlgitem(hwnd, IDC_EDIT_TEXT), WM_COPY, 0, 0);
                  Sendmessage(Getdlgitem(hwnd, IDC_EDIT_TEXT), EM_SETSEL, dw1, dw2);
                  SetFocus(Getdlgitem(hwnd, IDC_EDIT_TEXT));
                end;
              IDC_BUTTON_CLEAR:
                begin
                  Sendmessage(Getdlgitem(hwnd, IDC_EDIT_TEXT), WM_SETTEXT, 0, 0);
                  SetFocus(Getdlgitem(hwnd, IDC_EDIT_TEXT));
                end;
              IDC_BUTTON_PASTE:
                begin
                  Sendmessage(Getdlgitem(hwnd, IDC_EDIT_TEXT), WM_PASTE, 0, 0);
                  SetFocus(Getdlgitem(hwnd, IDC_EDIT_TEXT));
                end;
              IDC_BUTTON_BOFH:
                begin
                  BOFH := not BOFH;
                  bofhcheck;
                end;
              IDC_BUTTON_SEND:
                if can_start then begin

                  emptyerror;
                  Zeromemory(pchar(@buffer[0]), sizeof(buffer));
                  Zeromemory(pchar(@buf[0]), sizeof(buf));
                  getdlgitemtext(hwnd, IDC_EDIT_TEXT, pchar(@buf[0]), MAX_MSG);
                  Threadbuffer.request_type := 3; //NET SEND
                  Threadbuffer.message := string(pchar(@buf[0]));
                  case BOFH of
                    TRUE: begin
                        GETITEMS;
                        setlength(Threadbuffer.systems, length(names));
                        for itms := 0 to length(names) - 1 do
                          Threadbuffer.systems[itms] := names[itms];
                      end;
                    FALSE: begin
                        getdlgitemtext(hwnd, IDC_BUTTON_MACHINE, pchar(@buffer[0]), MAX_MSG);
                        setlength(Threadbuffer.systems, 1);
                        Threadbuffer.systems[0] := string(pchar(@buffer[0]));
                      end;
                  end;
                  Threadhandle := CreateThread(nil, 0, @Threadfunc, nil, 0, ThreadID);
                end;
              IDC_BUTTON_ABORT:
                if can_start then begin
                  emptyerror;
                  Zeromemory(pchar(@buffer[0]), sizeof(buffer));
                  Zeromemory(pchar(@buf[0]), sizeof(buf));
                  Threadbuffer.request_type := 2; //ABORT
                  case BOFH of
                    TRUE: begin
                        GETITEMS;
                        setlength(Threadbuffer.systems, length(names));
                        for itms := 0 to length(names) - 1 do
                          Threadbuffer.systems[itms] := names[itms];
                      end;
                    FALSE: begin
                        getdlgitemtext(hwnd, IDC_BUTTON_MACHINE, pchar(@buffer[0]), MAX_MSG);
                        setlength(Threadbuffer.systems, 1);
                        Threadbuffer.systems[0] := string(pchar(@buffer[0]));
                      end;
                  end;
                  Threadhandle := CreateThread(nil, 0, @Threadfunc, nil, 0, ThreadID);
                end;
              IDC_BUTTON_REBOOT:
                if can_start then begin
                  emptyerror;
                  Zeromemory(pchar(@buffer[0]), sizeof(buffer));
                  Zeromemory(pchar(@buf[0]), sizeof(buf));
                  getdlgitemtext(hwnd, IDC_EDIT_TEXT, pchar(@buf[0]), MAX_MSG);
                  Threadbuffer.request_type := 1; //SHUTDOWN
                  Threadbuffer.message := string(pchar(@buf[0]));
                  Threadbuffer.duration := GetDlgItemInt(hwnd, IDC_EDIT_DELAY, lpTranslated, FALSE);
                  case lpTranslated of
                    false: begin
                        Threadbuffer.duration := 0;
                        Setdlgitemtext(hwnd, IDC_EDIT_DELAY, pchar('0'));
                      end;
                  end;
                  Threadbuffer.boot := ischecked(IDC_CHECK1);
                  Threadbuffer.force := ischecked(IDC_CHECK2);
                  case BOFH of
                    TRUE: begin
                        GETITEMS;
                        setlength(Threadbuffer.systems, length(names));
                        for itms := 0 to length(names) - 1 do
                          Threadbuffer.systems[itms] := names[itms];
                      end;
                    FALSE: begin
                        getdlgitemtext(hwnd, IDC_BUTTON_MACHINE, pchar(@buffer[0]), MAX_MSG);
                        setlength(Threadbuffer.systems, 1);
                        Threadbuffer.systems[0] := string(pchar(@buffer[0]));
                      end;
                  end;
                  Threadhandle := CreateThread(nil, 0, @Threadfunc, nil, 0, ThreadID);

                end;
            end;
          end;
        end;
      end;
  else result := false;
  end;
end;

procedure kick_(message: pchar);
begin
  case commandtype of
    -1: begin
        messagebox(0, message, pchar(err + ' - Quitting'), MB_OK);
        halt($FF);
      end;
  else begin
      writeln(Err + ': ' + message);
      readkey;
      halt;
    end;
  end;
end;

procedure GUIpart;
begin
  initacomctl;
  LANMAN_DLL := GetModuleHandle('NTLANMAN.DLL');
  if LANMAN_DLL = 0 then
    LANMAN_DLL := LoadLibrary('NTLANMAN.DLL');
  if LANMAN_DLL <> 0 then begin
    @ServerBrowseDialogA0 := GetProcAddress(LANMAN_DLL, 'ServerBrowseDialogA0');
    if @ServerBrowseDialogA0 = nil then kick_(err_noentry + ServerBrowseDialogA0_name);
  end;

  appIcon := LoadIcon(hInstance, MAKEINTRESOURCE(1));

  initcommoncontrols;

  DialogBox(HInstance, MAKEINTRESOURCE(IDD_DIALOG1), 0, @DlgFunc);
end;

procedure CMDpart(command: integer);
begin
  currtextattr := textattribute;
  settextattribute(FOREGROUND_BLUE or FOREGROUND_INTENSITY);
  writeln(cmd_show_header);
  settextattribute(currtextattr);
  case command of
    1, 2, 3, 4: begin
        Threadhandle := CreateThread(nil, 0, @Threadfunc, nil, 0, ThreadID);
        if threadhandle <> INVALID_HANDLE_VALUE then threadruns := true;
//obviously the thread is to slow. before it sets "threadruns" the program terminates!
//so I have to set it manually :(
        while threadruns do sleep(1);
      end;
  else begin
      writeln(cmd_show_syntax);
      case command of
        0: begin
            writeln(press_anykey);
            readkey;
          end;
        //on help request display wait if the console was started by
        //RShutdown2 this will prevent the program to close w/o user action
      end;
      halt;
    end;
  end;
//  readkey;
end;

procedure parsefile(fname: string);
var s: string;
  f: textfile;
begin
  if fileexists(fname) then
  try
    assignfile(f, fname);
    reset(f);
    while not eof(f) do begin
      readln(f, s);
      if s <> '' then begin
        while s[1] = '\' do delete(s, 1, 1);
        setlength(Threadbuffer.systems, length(Threadbuffer.systems) + 1);
        Threadbuffer.systems[length(Threadbuffer.systems) - 1] := '\\' + s;
      end;
    end;
  finally
    closefile(f);
  end else begin
  end;
end;

procedure parsecommands;
var txt: string;
  parseparam: integer;
begin
  txt := '';
  setconsoletitle(pchar(progname));
  if lstrcmpi(pchar(copy(cmds[0], 1, length(cmd_help))), pchar(cmd_help)) = 0 then
    commandtype := 0 else
    if lstrcmpi(pchar(copy(cmds[0], 1, length(cmd_send))), pchar(cmd_send)) = 0 then
      commandtype := 1 else
      if lstrcmpi(pchar(copy(cmds[0], 1, length(cmd_reboot))), pchar(cmd_reboot)) = 0 then
        commandtype := 2 else
        if lstrcmpi(pchar(copy(cmds[0], 1, length(cmd_shutdown))), pchar(cmd_shutdown)) = 0 then
          commandtype := 3 else
          if lstrcmpi(pchar(copy(cmds[0], 1, length(cmd_abort))), pchar(cmd_abort)) = 0 then
            commandtype := 4;

  case commandtype of
    1: if cmds[1][1] <> ':' then commandtype := $FF else begin
        txt := copy(cmds[1], 2, length(cmds[1]));
        if txt[1] = '"' then delete(txt, 1, 1);
        if txt[length(txt)] = '"' then delete(txt, length(txt), 1);
        Threadbuffer.message := txt;
        Threadbuffer.request_type := 3;
        if lstrcmpi(pchar(cmds[2]), pchar(cmd_file)) = 0 then parsefile(cmds[3])
        else if lstrcmpi(pchar(cmds[2]), pchar(cmd_machine)) = 0 then begin
          while cmds[3][1] = '\' do delete(cmds[3], 1, 1);
          setlength(Threadbuffer.systems, 1);
          Threadbuffer.systems[0] := '\\' + cmds[3];
        end;
      end;
    2, 3: begin
        parseparam := 1;
        if cmds[1][1] <> ':' then Threadbuffer.message := '' else begin
          parseparam := 2;
          txt := copy(cmds[1], 2, length(cmds[1]));
          if txt[1] = '"' then delete(txt, 1, 1);
          if txt[length(txt)] = '"' then delete(txt, length(txt), 1);
          Threadbuffer.message := txt;
        end;
        Threadbuffer.request_type := 1;
        case commandtype of
          2: Threadbuffer.boot := true;
          3: Threadbuffer.boot := false;
        end;
        Threadbuffer.force := true;
        if lstrcmpi(pchar(cmds[parseparam]), pchar(cmd_file)) = 0 then parsefile(cmds[parseparam + 1])
        else if lstrcmpi(pchar(cmds[parseparam]), pchar(cmd_machine)) = 0 then begin
          while cmds[parseparam + 1][1] = '\' do delete(cmds[parseparam + 1], 1, 1);
          setlength(Threadbuffer.systems, 1);
          Threadbuffer.systems[0] := '\\' + cmds[parseparam + 1];
        end;
        if cmds[parseparam + 2] <> '' then
          if cmds[parseparam + 2][1] = '/' then begin
            txt := copy(cmds[parseparam + 2], 2, length(cmds[parseparam + 2]));
            Threadbuffer.duration := _strtoint(txt);
          end else Threadbuffer.duration := 0;
      end;
    4: if cmds[1][1] = ':' then commandtype := 0 else begin
        Threadbuffer.request_type := 2;
        if lstrcmpi(pchar(cmds[1]), pchar(cmd_file)) = 0 then parsefile(cmds[2])
        else if lstrcmpi(pchar(cmds[1]), pchar(cmd_machine)) = 0 then begin
          while cmds[2][1] = '\' do delete(cmds[2], 1, 1);
          setlength(Threadbuffer.systems, 1);
          Threadbuffer.systems[0] := '\\' + cmds[2];
        end;
      end;
  end;
end;

var
  dummy: string;
  i: integer;

begin
  osinfo.dwOSVersionInfoSize := sizeof(TOSVERSIONinfo);
  if BOOL(GetVersionEx(osinfo)) then
    if osinfo.dwPlatformId <> VER_PLATFORM_WIN32_NT then kick_(err_noNT);

  case paramcount of
    0: freeconsole;
    1: if lstrcmpi(pchar(paramstr(1)), pchar('/BOFH')) = 0 then begin
        freeconsole;
        BOFH := true;
      end;
  end;
  if not BOFH then if paramcount > 2 then begin
      for i := 0 to length(cmds) - 1 do begin
        dummy := paramstr(i + 1);
        cmds[i] := copy(dummy, 1, length(dummy));
      end;
      parsecommands;
      if lstrcmpi(pchar(paramstr(paramcount)), cmd_yes) = 0 then noPrompt := true;
    end;

  LANMAN_DLL := GetModuleHandle('NETAPI32.DLL');
  if LANMAN_DLL = 0 then
    LANMAN_DLL := LoadLibrary('NETAPI32.DLL');
  if LANMAN_DLL <> 0 then begin
    @NetMessageBufferSend := GetProcAddress(LANMAN_DLL, 'NetMessageBufferSend');
    if @NetMessageBufferSend = nil then kick_(err_noentry + NetMessageBufferSend_name);
    @NetServerEnum := GetProcAddress(LANMAN_DLL, NetServerEnum_name);
    if @NetServerEnum = nil then kick_(err_noentry + NetServerEnum_name);
    @NetApiBufferFree := GetProcAddress(LANMAN_DLL, NetApiBufferFree_name);
    if @NetApiBufferFree = nil then kick_(err_noentry + NetApiBufferFree_name);
  end;

  size := SizeOf(cbuffer);
  GetComputerName(cbuffer, size);
  compname := string(cbuffer);
  if compname[1] <> '\' then compname := '\\' + compname;
  case commandtype of
    -1: GUIpart;
  else CMDpart(commandtype); //0, 1, 2, 3, 4:
  end;
end.

